SUBROUTINE sub_refinement(left_loc,len,cash,exp_value_in,&
    &a_prime,val_refinement)



USE mod_types
USE mod_common_var
USE mod_felicity

IMPLICIT NONE

INTEGER, INTENT(in) :: left_loc,len
	
REAL (dp), INTENT(in) 			:: cash
REAL (dp), DIMENSION(left_loc:left_loc+len), INTENT(in) :: exp_value_in
REAL (dp), INTENT(inout) 		:: a_prime, val_refinement

REAL (dp) :: a_prime_l, a_prime_m, a_prime_h, c, exp_value, val_comp
INTEGER   :: node


a_prime_l = a_grid(left_loc)
a_prime_h = a_grid(left_loc+len)

DO 
  a_prime_m = 0.5d0*(a_prime_l+a_prime_h)
  c = cash - a_prime_m
  IF (c<0.0) THEN
    c = 1.d-6
  ENDIF

  IF (a_prime_m>a_grid(left_loc+1) .AND. len==2) THEN
    node = left_loc + 1
  ELSE 
    node = left_loc
  END IF
  
      exp_value = exp_value_in(node) + &
        ( exp_value_in(node+1) - exp_value_in(node) )/ &
        ( a_grid(node+1) - a_grid(node) ) * ( a_prime_m - a_grid(node) )
    
      val_comp = fel(c) + exp_value
				
      IF (val_comp>val_refinement) THEN
        IF (a_prime_m<a_prime) THEN
          a_prime_h = a_prime
        ELSE
          a_prime_l = a_prime
        ENDIF
        a_prime = a_prime_m
        val_refinement = val_comp 
      ELSE
        IF (a_prime_m<a_prime) THEN
          a_prime_l = a_prime_m
        ELSE
          a_prime_h = a_prime_m
        ENDIF
      ENDIF
      
      IF (ABS(a_prime_h-a_prime_l)<1.d-8) THEN
        a_prime = 0.5d0*(a_prime_l+a_prime_h)
        EXIT
      END IF
      
    ENDDO
	
end subroutine sub_refinement
